Unit AMMFR_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMMFR(var A :Array of Real; N :Integer; NLA :Integer;
                NUA :Integer; var B :Array of Real;
                var C :Array of Real); 
implementation

procedure AMMFR(var A :Array of Real; N :Integer; NLA :Integer;
                NUA :Integer; var B :Array of Real;
                var C :Array of Real);
var
I,J,K,IBEG,KBEG,KEND,JCNT,N1MN3,IBEG1,ICNT,KKK,ICNTO :Integer;
SUM :Real;
label
_5,_10,_15,_20,_25,_30;
begin
KBEG := 1 + NLA;
KEND := KBEG + NUA;
JCNT := 0;
N1MN3 := N - NUA;
for I:=1 to N do
 begin
  IBEG1 := 1;
  for J:=1 to N do
   begin
    IBEG := IBEG1;
    ICNT := 0;
    SUM := 0.0;
    if ( I <= NLA+1 ) 
     then goto _15;
    IBEG := IBEG + Min0(JCNT, J-1);
    if ( JCNT < J ) 
     then goto _10;
    for KKK:=J to JCNT do
     begin
      IBEG := IBEG + KKK;
_5:
     end;
_10:
    ICNT := JCNT;
_15:
    for K:=KBEG to KEND do
     begin
      ICNTO := ICNT;
      ICNT := ICNT + 1;
      SUM := SUM + A[(I-1)+(K-1)*N] * B[IBEG-1];
      IBEG := IBEG + 1;
      if ( ICNT >= J ) 
       then IBEG := IBEG + ICNTO;
_20:
     end;
    C[(I-1)+(J-1)*N] := SUM;
    IBEG1 := IBEG1 + J;
_25:
   end;
  if ( I > NLA ) 
   then JCNT := JCNT + 1;
  if ( I >= N1MN3 ) 
   then KEND := KEND - 1;
  KBEG := Max0(KBEG-1, 1);
_30:
 end;
end;

end.
